!C   Copyright (C) 2004-2005 The SSI Project. All rights reserved.
!C   http://ssi.is.s.u-tokyo.ac.jp/
!C
!C   This software is distributed in the hope that it will be useful,
!C   but WITHOUT ANY WARRANTY.  See the LICENSE file for the precise
!C   terms and conditions for the use of this software.

MODULE data_structure_for_AMG
  IMPLICIT NONE
  INCLUDE 'precision.inc'
  
  INTEGER, parameter :: SWITCH_SIZE    = 1700
  INTEGER, parameter :: MAX_LEVEL_SIZE = 10
  INTEGER, parameter :: MIN_NODE_SIZE  = 90
  INTEGER, parameter :: TIME_KINDS     = 10
  
  TYPE row_node
     INTEGER(kind=kint) :: column
     REAL(kind=kreal)   :: value
  END TYPE row_node
  
  TYPE INTER_LEVEL_OPERATOR
     integer(kind=kint) :: ROW_SIZE
     integer(kind=kint),  pointer :: IN(:)
     integer(kind=kint),  pointer :: CN(:)
     real   (kind=kreal), pointer :: V(:)
  END TYPE INTER_LEVEL_OPERATOR
  
!!$  type COMMUNICATION_TABLE
!!$     integer(kind=kint) :: NEIBPETOT
!!$     integer(kind=kint), pointer :: NEIBPE(:)
!!$     integer(kind=kint), pointer :: STACK_IMPORT(:)
!!$     integer(kind=kint), pointer :: STACK_EXPORT(:)
!!$     integer(kind=kint), pointer :: NOD_IMPORT(:)
!!$     integer(kind=kint), pointer :: NOD_EXPORT(:)
!!$  end type COMMUNICATION_TABLE
  
  TYPE DATA_FOR_EACH_LEV
     integer(kind=kint ) :: N, NP, NPL, NPU
     integer(kind=kint ), pointer :: INU(:), INL(:)
     integer(kind=kint ), pointer :: IAU(:), IAL(:)
     real   (kind=kreal), pointer :: AU(:), AL(:), D(:), X(:), B(:)
     
!!$     type(COMMUNICATION_TABLE) :: COMM_TABLE
!!$     type(COMMUNICATION_TABLE) :: INT_LVL_TABLE
     TYPE(INTER_LEVEL_OPERATOR), pointer :: R, P
  END TYPE DATA_FOR_EACH_LEV
  
  TYPE (DATA_FOR_EACH_LEV) :: HIERARCHICAL_DATA(MAX_LEVEL_SIZE)
  
!C Rate_Of_Space * mesh size is the width of the next coarser 
!C level's restriction
!!$  real (kind=kreal) :: RATE_OF_SPACE
!!$  real (kind=kreal),parameter :: EPS = 1.E-13
  real (kind=kreal),  parameter :: EPS = 1.E-10
  real (kind=kreal),  parameter :: EPS_COARSEST = 1.E-5
  INTEGER(kind=kint), parameter :: NODE_RECORD_SIZE=300
  
end module data_structure_for_AMG







