.SUFFIXES: .o .f90 .c

.c.o:; 		$(CC) -c $(FLAGS) $(CFLAGS) $(COMMONFLAGS) $<
.f90.o:;	$(FC) -c $(FLAGS) $(FFLAGS) $(COMMONFLAGS) $<

TARGET = liblis$(mode).a

OBJS  = \
lis_solver.o \
lis_solver_cg.o \
lis_solver_bicg.o \
lis_solver_bicgstab.o \
lis_solver_bicgstabl.o \
lis_solver_cgs.o \
lis_solver_qmr.o \
lis_solver_gmres.o \
lis_solver_gpbicg.o \
lis_solver_gs.o \
lis_solver_jacobi.o \
lis_solver_orthomin.o \
lis_solver_sor.o \
lis_vector.o \
lis_matvec.o \
lis_matrix.o \
lis_matrix_conv.o \
lis_matrix_scaling.o \
lis_matrix_diag.o \
lis_matrix_mpi.o \
lis_matrix_copy.o \
lis_matrix_print.o \
lis_matrix_split.o \
lis_precon.o \
lis_precon_ilu.o \
lis_precon_iluk.o \
lis_precon_is.o \
lis_precon_ssor.o \
lis_precon_hybrid.o \
lis_precon_jacobi.o \
lis_precon_sainv.o \
lis_input.o \
lis_output.o \
lis_output_mm.o \
lis_output_mmb.o \
lis_input_mm.o \
lis_input_lis.o \
lis_input_hb.o \
lis_util.o \
lis_init.o \
lis_sort.o 

all:	$(TARGET)

$(TARGET):$(OBJS) 
	ar cru $@ $(OBJS)
	$(RANLIB) $@
	cp $@ ../$@

liblis$(mode).so:$(OBJS)
	$(CC) $(SHAREDLDFLAGS) -o $@ $(OBJS)
	cp $@ ../$@

lis_matrix.o: lis_matrix.c
lis_matrix_conv.o: lis_matrix_conv.c
lis_matrix_copy.o: lis_matrix_copy.c
lis_matrix_print.o: lis_matrix_print.c
lis_matrix_split.o: lis_matrix_split.c
lis_matrix_mpi.o: lis_matrix_mpi.c
lis_matrix_diag.o: lis_matrix_diag.c
lis_matrix_scaling.o: lis_matrix_scaling.c
lis_matvec.o: lis_matvec.c
lis_vector.o: lis_vector.c
lis_solver.o: lis_solver.c
lis_solver_cg.o: lis_solver_cg.c
lis_solver_bicg.o: lis_solver_bicg.c
lis_solver_cgs.o: lis_solver_cgs.c
lis_solver_bicgstab.o: lis_solver_bicgstab.c
lis_solver_bicgstabl.o: lis_solver_bicgstabl.c
lis_solver_gpbicg.o: lis_solver_gpbicg.c
lis_solver_orthomin.o: lis_solver_orthomin.c
lis_solver_gmres.o: lis_solver_gmres.c
lis_solver_qmr.o: lis_solver_qmr.c
lis_solver_jacobi.o: lis_solver_jacobi.c
lis_solver_gs.o: lis_solver_gs.c
lis_solver_sor.o: lis_solver_sor.c
lis_precon.o: lis_precon.c
lis_precon_ilu.o: lis_precon_ilu.c
lis_precon_iluk.o: lis_precon_iluk.c
lis_precon_is.o: lis_precon_is.c
lis_precon_hybrid.o: lis_precon_hybrid.c
lis_precon_jacobi.o: lis_precon_jacobi.c
lis_precon_sainv.o: lis_precon_sainv.c
lis_precon_ssor.o: lis_precon_ssor.c
lis_input.o: lis_input.c
lis_input_mm.o: lis_input_mm.c
lis_input_hb.o: lis_input_hb.c
lis_input_ssi.o: lis_input_ssi.c
lis_output.o: lis_output.c
lis_output_mm.o: lis_output_mm.c
lis_output_mmb.o: lis_output_mmb.c
lis_util.o: lis_util.c
lis_sort.o: lis_sort.c
lis_init.o: lis_init.c

clean:
	rm -f *.a *.o $(TARGET) *.mod *~

